#include "MirfSoftwareSpiDriver.h"
#include <digitalWriteFast.h>
#include <Arduino.h>

uint8_t MirfSoftwareSpiDriver::transfer(uint8_t data){
	unsigned char i;
        uint8_t adata = data;
	for(i=0;i<8;i++) {
		if(adata&0x80) {
			digitalWriteFast2(mosi_pin, 1);
		} else {
			digitalWriteFast2(mosi_pin, 0);
		}
		digitalWriteFast2(sck_pin, 1);
		adata <<= 1;
		if(digitalReadFast2(miso_pin) == 1) {
			adata |= 1;
		}
		digitalWriteFast2(sck_pin, 0); 
	}
	return (adata);
}

void MirfSoftwareSpiDriver::set_pins(uint8_t sck, uint8_t mosi, uint8_t miso){
	sck_pin = sck;
	mosi_pin = mosi;
	miso_pin = miso;
	pinMode(sck_pin, OUTPUT);
	pinMode(mosi_pin, OUTPUT);
	pinMode(miso_pin, INPUT);
}

void MirfSoftwareSpiDriver::begin(){

}

void MirfSoftwareSpiDriver::end(){
}

//MirfSoftwareSpiDriver MirfSoftwareSpi;
